#include "engine.h"
#include <math.h>
#pragma pack(1)
#define NUM_Pie                                3.14159265358979323846

struct OneEDGE
{
       SWORD BegX,EndX;
};

DATA__Camera   *Camera;
DATA_VertexL   *VertexL;
DATA_VectorL   *VectorL;
DATA_TRotAdd   *TRotAdd;
DATA_TMatrix   *TMatrix;
DATA_ClpLine   *ClpLine;
ColorVal       *Texture;
OneEDGE        *Edges;
FLOATINGPOINT  *ZBuffer;
DWORD           Facing=0;

void Init3DObject(void)
{
     VertexL[0].BegX=-32000000;
     VertexL[0].BegY= 32000000;
     VertexL[0].BegZ=  0;
     VertexL[0].EndX= 32000000;
     VertexL[0].EndY= 32000000;
     VertexL[0].EndZ=  0;

     VertexL[1].BegX= 32000000;
     VertexL[1].BegY= 32000000;
     VertexL[1].BegZ=  0;
     VertexL[1].EndX= 32000000;
     VertexL[1].EndY=-32000000;
     VertexL[1].EndZ=  0;

     VertexL[2].BegX= 32000000;
     VertexL[2].BegY=-32000000;
     VertexL[2].BegZ=  0;
     VertexL[2].EndX=-32000000;
     VertexL[2].EndY=-32000000;
     VertexL[2].EndZ=  0;

     VertexL[3].BegX=-32000000;
     VertexL[3].BegY=-32000000;
     VertexL[3].BegZ=  0;
     VertexL[3].EndX=-32000000;
     VertexL[3].EndY= 32000000;
     VertexL[3].EndZ=  0;

     VertexL[4].BegX=-32000000;  // texture origin
     VertexL[4].BegY=-32000000;
     VertexL[4].BegZ=  0;
     VertexL[4].EndX=  0; // not used
     VertexL[4].EndY=  0; // not used
     VertexL[4].EndZ=  0; // not used

     VertexL[5].BegX=-32000000;
     VertexL[5].BegY= 32000000;
     VertexL[5].BegZ=  0;
     VertexL[5].EndX= 32000000;
     VertexL[5].EndY= 32000000;
     VertexL[5].EndZ=  0;

     VertexL[6].BegX= 32000000;
     VertexL[6].BegY= 32000000;
     VertexL[6].BegZ=  0;
     VertexL[6].EndX= 32000000;
     VertexL[6].EndY=-32000000;
     VertexL[6].EndZ=  0;

     VertexL[7].BegX= 32000000;
     VertexL[7].BegY=-32000000;
     VertexL[7].BegZ=  0;
     VertexL[7].EndX=-32000000;
     VertexL[7].EndY=-32000000;
     VertexL[7].EndZ=  0;

     VertexL[8].BegX=-32000000;
     VertexL[8].BegY=-32000000;
     VertexL[8].BegZ=  0;
     VertexL[8].EndX=-32000000;
     VertexL[8].EndY= 32000000;
     VertexL[8].EndZ=  0;

     VertexL[9].BegX=-32000000;  // texture origin
     VertexL[9].BegY=-32000000;
     VertexL[9].BegZ=  0;
     VertexL[9].EndX=  0; // not used
     VertexL[9].EndY=  0; // not used
     VertexL[9].EndZ=  0; // not used

     VectorL[0].BegX= 0;
     VectorL[0].BegY=-1;
     VectorL[0].BegZ= 0;
     VectorL[0].EndX= 1;
     VectorL[0].EndY= 0;
     VectorL[0].EndZ= 0;

     VectorL[1].BegX= 0;
     VectorL[1].BegY=-1;
     VectorL[1].BegZ= 0;
     VectorL[1].EndX= 1;
     VectorL[1].EndY= 0;
     VectorL[1].EndZ= 0;

     TRotAdd[0].AddX=TRotAdd[0].AddY=TRotAdd[0].AddZ=0;
     TRotAdd[0].RotX=-80;
     TRotAdd[0].RotY=0;
     TRotAdd[0].RotZ=0;                        // object1 rotation
     TRotAdd[1].AddX=0;
     TRotAdd[1].AddY=0;
     TRotAdd[1].AddZ=100.0;//550;              // object1 position
     TRotAdd[1].RotX=TRotAdd[1].RotY=TRotAdd[1].RotZ=0;
     TRotAdd[2].AddX=TRotAdd[2].AddY=TRotAdd[2].AddZ=0;
     TRotAdd[2].RotX=80;
     TRotAdd[2].RotY=0;
     TRotAdd[2].RotZ=0;                        // object2 rotation
     TRotAdd[3].AddX=0;
     TRotAdd[3].AddY=0;
     TRotAdd[3].AddZ=100.0;//550;              // object2 position
     TRotAdd[3].RotX=TRotAdd[3].RotY=TRotAdd[3].RotZ=0;
     TRotAdd[4].AddX=TRotAdd[4].AddY=TRotAdd[4].AddZ=0;
     TRotAdd[4].RotX=0;
     TRotAdd[4].RotY=0;
     TRotAdd[4].RotZ=0;                        // world rotation
     TRotAdd[0].FixMul=
      TRotAdd[1].FixMul=
       TRotAdd[2].FixMul=
        TRotAdd[3].FixMul=
         TRotAdd[4].FixMul=(FLOATINGPOINT)NUM_Pie/(FLOATINGPOINT)180;
}

void InitCamera(void)
{
     Camera[0].BegX     =  0.0000e+00;
     Camera[0].BegY     =  0.0000e+00;
     Camera[0].EndX     =  0.3190e+03;
     Camera[0].EndY     =  0.1990e+03;
     Camera[0].MidX     =  0.1600e+03;
     Camera[0].MidY     =  0.1000e+03;
     Camera[0].Scale    =  0.2560e+03;
     Camera[0].FocalDist=  0.5000e+01;
}

void LoadBitmapInText(const char *FileName,DWORD AddAmount)
{
     HFILE hf;
     DWORD NumR;
     struct
     {
            BYTE B,G,R;
     }Col;
     hf=_lopen(FileName,OF_READ);
     _llseek(hf,-12288,FILE_END);
     for (NumR=0;NumR<4096;NumR++)
     {
         _lread(hf,&Col,3);
         Texture[NumR+AddAmount].Bits.R=Col.R>>3;
         Texture[NumR+AddAmount].Bits.G=Col.G>>2;
         Texture[NumR+AddAmount].Bits.B=Col.B>>3;
     }
     _lclose(hf);
}

BOOL Engine_Init(void)
{
     VertexL=(DATA_VertexL   *)malloc(sizeof(DATA_VertexL  )*200);//21
     VectorL=(DATA_VectorL   *)malloc(sizeof(DATA_VectorL  )*200);
     TRotAdd=(DATA_TRotAdd   *)malloc(sizeof(DATA_TRotAdd  )*   5);
     TMatrix=(DATA_TMatrix   *)malloc(sizeof(DATA_TMatrix  )*   5);
     ClpLine=(DATA_ClpLine   *)malloc(sizeof(DATA_ClpLine  )*200);//14
     Camera =(DATA__Camera   *)malloc(sizeof(DATA__Camera  )*   1);
     Edges  =(OneEDGE        *)malloc(sizeof(OneEDGE       )* 200);
     ZBuffer=(FLOATINGPOINT  *)malloc(sizeof(FLOATINGPOINT )*64000);
     Texture=(ColorVal       *)malloc(sizeof(ColorVal      )*(4096*11));
     if (VertexL==NULL)return(FALSE);
     if (VectorL==NULL)return(FALSE);
     if (TRotAdd==NULL)return(FALSE);
     if (TMatrix==NULL)return(FALSE);
     if (ClpLine==NULL)return(FALSE);
     if (Camera ==NULL)return(FALSE);
     if (Edges  ==NULL)return(FALSE);
     if (ZBuffer==NULL)return(FALSE);
     if (Texture==NULL)return(FALSE);
     Init3DObject();
     InitCamera();
     // load only 11
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv1.bmp"         , 0<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv2.bmp"         , 1<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv3.bmp"         , 2<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv4.bmp"         , 3<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv5.bmp"         , 4<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\fence2.bmp"      , 5<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\hwall.bmp"       , 6<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\window.bmp"      , 7<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\door.bmp"        , 8<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\bush.bmp"        , 9<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\grass.bmp"       ,10<<12);
     return(TRUE);
}

void SetEdges(void)
{    WORD EdgeLoop;
     for (EdgeLoop=0;EdgeLoop<200;EdgeLoop++)
     {
         Edges[EdgeLoop].BegX= 321;
         Edges[EdgeLoop].EndX=  -1;
     }
}

/*void PutPixel(register WORD     BegX
             ,register WORD     BegY
             ,ColorVal         *Adr
             ,         ColorVal Col
             )
{
     DWORD ScrAddr;
     if ((BegX<320)&&(BegY<200))
     {
        ScrAddr=BegX+(BegY<<8)+(BegY<<6);
        Adr[ScrAddr]=Col;
     }
}
  */
void Line(register SDWORD  BegX
         ,register SDWORD  BegY
         ,         SDWORD  EndX
         ,         SDWORD  EndY
         ,ColorVal        *Adr
         ,ColorVal         Col
         )
{    SDWORD  DelX,DelY,AddYH,AddXH,AddYL,AddXL,Accum,AddAH,AddAL;
     DWORD   LargeDist,SmallDist,LineL;

     DelX=EndX-BegX;
     DelY=EndY-BegY;
     if (DelX<0)
     {
        DelX       =-DelX;
        AddXH=AddXL=-1;
     }  else
     {
        AddXH=AddXL= 1;
     }
     if (DelY<0)
     {
        DelY       =-DelY;
        AddYH=AddYL=-1;
     }  else
     {
        AddYH=AddYL= 1;
     }
     if (DelX>DelY)
     {
        LargeDist=DelX;
        SmallDist=DelY;
        AddYL=0;
     }  else
     {
        LargeDist=DelY;
        SmallDist=DelX;
        AddXL=0;
     }
     SmallDist<<=1;
     Accum=SmallDist-LargeDist;
     AddAL=SmallDist;
     AddAH=SmallDist-(LargeDist<<1);
     for (LineL=0;LineL<=LargeDist;LineL++)
     {

         if (  (BegX>=0)
             &&(BegY>=0)
             &&(BegX<320)
             &&(BegY<200))
            Adr[(BegY*320)+BegX]=Col;
         if (Accum>=0)
         {
            BegX +=AddXH;
            BegY +=AddYH;
            Accum+=AddAH;
         }  else
         {  BegX +=AddXL;
            BegY +=AddYL;
            Accum+=AddAL;
         }
     }

}

void DrawEdge(register SWORD  BegX
             ,register SWORD  BegY
             ,         SWORD  EndX
             ,         SWORD  EndY
             )
{    SWORD  DelX,DelY,AddYH,AddXH,AddYL,AddXL,Accum,AddAH,AddAL;
     WORD   LargeDist,SmallDist,LineL;

     DelX=EndX-BegX;
     DelY=EndY-BegY;
     if (DelX<0)
     {
        DelX       =-DelX;
        AddXH=AddXL=-1;
     }  else
     {
        AddXH=AddXL= 1;
     }
     if (DelY<0)
     {
        DelY       =-DelY;
        AddYH=AddYL=-1;
     }  else
     {
        AddYH=AddYL= 1;
     }
     if (DelX>DelY)
     {
        LargeDist=DelX;
        SmallDist=DelY;
        AddYL=0;
     }  else
     {
        LargeDist=DelY;
        SmallDist=DelX;
        AddXL=0;
     }
     SmallDist<<=1;
     Accum=SmallDist-LargeDist;
     AddAL=SmallDist;
     AddAH=SmallDist-(LargeDist<<1);
     for (LineL=0;LineL<=LargeDist;LineL++)
     {

         if (  (BegX>=0)
             &&(BegY>=0)
             &&(BegX<320)
             &&(BegY<200))
         {
            if (BegX<Edges[BegY].BegX)Edges[BegY].BegX=BegX;
            if (BegX>Edges[BegY].EndX)Edges[BegY].EndX=BegX;
         }
         if (Accum>=0)
         {
            BegX +=AddXH;
            BegY +=AddYH;
            Accum+=AddAH;
         }  else
         {  BegX +=AddXL;
            BegY +=AddYL;
            Accum+=AddAL;
         }
     }

}

void ProcessEdges(ColorVal     *Adr,
                  DATA_VertexL *Vrtx,
                  DATA_VectorL *Vctr,
                  DATA__Camera *Camm,
                  DWORD         AddTex)
{
     SDWORD CurE,LoopX;
     DATA_TxtScan Tsd;
     DWORD TX,TY;
     DWORD Color;
     DWORD ScrPoint;
//     ColorVal Pal;
     Tsd.Ox  =Vrtx[0].BegX;
     Tsd.Oy  =Vrtx[0].BegY;
     Tsd.Oz  =Vrtx[0].BegZ;
     Tsd.Vx  =Vctr[0].BegX;
     Tsd.Vy  =Vctr[0].BegY;
     Tsd.Vz  =Vctr[0].BegZ;
     Tsd.Ux  =Vctr[0].EndX;
     Tsd.Uy  =Vctr[0].EndY;
     Tsd.Uz  =Vctr[0].EndZ;
     Tsd.Ui  =(Tsd.  Vz*Tsd.  Oy)-(Tsd.  Oz*Tsd.  Vy);
     Tsd.Uj  =(Tsd.  Vx*Tsd.  Oz)-(Tsd.  Ox*Tsd.  Vz);
     Tsd.Uc  =(Tsd.  Vy*Tsd.  Ox)-(Tsd.  Oy*Tsd.  Vx);
     Tsd.Vi  =(Tsd.  Uy*Tsd.  Oz)-(Tsd.  Oy*Tsd.  Uz);
     Tsd.Vj  =(Tsd.  Uz*Tsd.  Ox)-(Tsd.  Oz*Tsd.  Ux);
     Tsd.Vc  =(Tsd.  Ux*Tsd.  Oy)-(Tsd.  Ox*Tsd.  Uy);
     Tsd.Zi  =(Tsd.  Vy*Tsd.  Uz)-(Tsd.  Uy*Tsd.  Vz);
     Tsd.Zj  =(Tsd.  Vz*Tsd.  Ux)-(Tsd.  Uz*Tsd.  Vx);
     Tsd.Zc  =(Tsd.  Vx*Tsd.  Uy)-(Tsd.  Ux*Tsd.  Vy);
     Tsd.FxIJ=1.0/Camm[0].Scale;
     Tsd.J   =-Camm[0].MidY*Tsd.FxIJ;
     Tsd.  Ju=(Tsd.   J*Tsd.  Uj)+Tsd.  Uc;
     Tsd.  Jv=(Tsd.   J*Tsd.  Vj)+Tsd.  Vc;
     Tsd.  Jz=(Tsd.   J*Tsd.  Zj)+Tsd.  Zc;
     Tsd.AdJu=Tsd.  Uj*Tsd.FxIJ;
     Tsd.AdJv=Tsd.  Vj*Tsd.FxIJ;
     Tsd.AdJz=Tsd.  Zj*Tsd.FxIJ;
     Tsd.  Au=Tsd.  Ui*Tsd.FxIJ;
     Tsd.  Av=Tsd.  Vi*Tsd.FxIJ;
     Tsd.AdFz=Tsd.  Zi*Tsd.FxIJ;

     for (CurE=0;CurE<200;CurE++)
     {
         if ((Edges[CurE].BegX>=0)&&(Edges[CurE].EndX<320))
         {  LoopX=Edges[CurE].BegX;
            Tsd.   I=((FLOATINGPOINT)LoopX-Camm[0].MidX)*Tsd.FxIJ;
	    Tsd.CrFz=Tsd.  Jz+(Tsd.   I*Tsd.  Zi);
	    Tsd.  Cu=Tsd.  Ju+(Tsd.   I*Tsd.  Ui);
	    Tsd.  Cv=Tsd.  Jv+(Tsd.   I*Tsd.  Vi);
            ScrPoint=(CurE<<8)+(CurE<<6)+LoopX;
	    for (;LoopX<=Edges[CurE].EndX;LoopX++)
	    {
		Tsd.   U=Tsd.  Cu/Tsd.CrFz;
		Tsd.   V=Tsd.  Cv/Tsd.CrFz;
		TX=(DWORD)Tsd.   U;
		TY=(DWORD)Tsd.   V;

                Tsd.   Z=Tsd.  Oz+(Tsd.   V*Tsd.  Vz)
                                 +(Tsd.   U*Tsd.  Uz);
                if (  (Tsd.   Z<=ZBuffer[ScrPoint])  )
                //    &&(Tsd.   Z>=Camm[0].FocalDist))
                {
                   ZBuffer[ScrPoint]=Tsd.   Z;
		   Color=(TY<<6)+TX;
                   Color&=0x00000FFF;
   //                if (Facing!=0)Pal=Texture[(DWORD)Color];
   //                         else Pal.Color16=0xFFFF;
   //                Adr[ScrPoint]=Pal;
                   Adr[ScrPoint]=Texture[(DWORD)Color+AddTex];
                }

		Tsd.CrFz+=Tsd.AdFz;
                Tsd.  Cu+=Tsd.  Au;
                Tsd.  Cv+=Tsd.  Av;
                ScrPoint++;
	    }
	 }
//         Tsd.   J+=Tsd.FxIJ;
         Tsd.  Ju+=Tsd.AdJu;
         Tsd.  Jv+=Tsd.AdJv;
         Tsd.  Jz+=Tsd.AdJz;
     }
}

void CameraForewardMotion(void)
{
     FLOATINGPOINT fl1,fl2;
     fl1=(-TRotAdd[2].RotY)+180;
     fl2=(-TRotAdd[2].RotX);
     TRotAdd[1].AddX+= sin(fl1*TRotAdd[2].FixMul);
     TRotAdd[1].AddY+= sin(fl2*TRotAdd[2].FixMul);
     TRotAdd[1].AddZ+= cos(fl1*TRotAdd[2].FixMul);
}

void CameraBackwardMotion(void)
{
     FLOATINGPOINT fl1,fl2;
     fl1=(-TRotAdd[2].RotY);
     fl2=(-TRotAdd[2].RotX)+180;
     TRotAdd[1].AddX+= sin(fl1*TRotAdd[2].FixMul);
     TRotAdd[1].AddY+= sin(fl2*TRotAdd[2].FixMul);
     TRotAdd[1].AddZ+= cos(fl1*TRotAdd[2].FixMul);
}

#define OBJROTATESPEED      1.0
#define EYEROTATESPEED      1.0
void ProcessKeyboardInput(void)
{
     if (GetKeyState(VK_SHIFT)&0x8000)
     {
        if (GetKeyState('W')&0x8000)
        {
	   TRotAdd[2].RotX-=OBJROTATESPEED;
        }else
        if (GetKeyState('S')&0x8000)
        {
	   TRotAdd[2].RotX+=OBJROTATESPEED;
        }
        if (GetKeyState('D')&0x8000)
        {
	   TRotAdd[2].RotY-=OBJROTATESPEED;
        }else
        if (GetKeyState('A')&0x8000)
        {
	   TRotAdd[2].RotY+=OBJROTATESPEED;
        }
        if (GetKeyState('Q')&0x8000)
        {
	   TRotAdd[2].RotZ-=OBJROTATESPEED;
        }else
        if (GetKeyState('E')&0x8000)
        {
	   TRotAdd[2].RotZ+=OBJROTATESPEED;
        }
     }else
     {
        if (GetKeyState('W')&0x8000)
        {
	   TRotAdd[0].RotX-=OBJROTATESPEED;
        }else
        if (GetKeyState('S')&0x8000)
        {
	   TRotAdd[0].RotX+=OBJROTATESPEED;
        }
        if (GetKeyState('D')&0x8000)
        {
	   TRotAdd[0].RotY-=OBJROTATESPEED;
        }else
        if (GetKeyState('A')&0x8000)
        {
	   TRotAdd[0].RotY+=OBJROTATESPEED;
        }
        if (GetKeyState('Q')&0x8000)
        {
	   TRotAdd[0].RotZ-=OBJROTATESPEED;
        }else
        if (GetKeyState('E')&0x8000)
        {
	   TRotAdd[0].RotZ+=OBJROTATESPEED;
        }
     }

     if ((GetKeyState('T')&0x8000)&&(TRotAdd[0].RotX>-90.0))
     {
	TRotAdd[4].RotX-=EYEROTATESPEED;
     }else
     if ((GetKeyState('G')&0x8000)&&(TRotAdd[0].RotX< 90.0))
     {
	TRotAdd[4].RotX+=EYEROTATESPEED;
     }
     if (GetKeyState('H')&0x8000)
     {
	TRotAdd[4].RotY-=EYEROTATESPEED;
     }else
     if (GetKeyState('F')&0x8000)
     {
	TRotAdd[4].RotY+=EYEROTATESPEED;
     }
     if (GetKeyState('R')&0x8000)
     {
	TRotAdd[4].RotZ-=EYEROTATESPEED;
     }else
     if (GetKeyState('Y')&0x8000)
     {
	TRotAdd[4].RotZ+=EYEROTATESPEED;
     }

     if (GetKeyState('1')&0x8000)TRotAdd[1].AddX-=10;else
     if (GetKeyState('2')&0x8000)TRotAdd[1].AddX+=10;
     if (GetKeyState('3')&0x8000)TRotAdd[1].AddY-=10;else
     if (GetKeyState('4')&0x8000)TRotAdd[1].AddY+=10;
     if (GetKeyState('5')&0x8000)TRotAdd[1].AddZ-=10;else
     if (GetKeyState('6')&0x8000)TRotAdd[1].AddZ+=10;
//     if (GetKeyState('7')&0x8000)TRotAdd[3].RotZ-=1;
//     if (GetKeyState('8')&0x8000)TRotAdd[3].RotZ+=1;
     if (GetKeyState('9')&0x8000)VertexL[4].BegX-=1;
     if (GetKeyState('0')&0x8000)VertexL[4].BegX+=1;
     if (GetKeyState('U')&0x8000)VertexL[4].BegY-=1;
     if (GetKeyState('I')&0x8000)VertexL[4].BegY+=1;
     if (GetKeyState('O')&0x8000)
     {
        VectorL[0].BegX*=1.1;
        VectorL[0].BegY*=1.1;
        VectorL[0].EndX*=1.1;
        VectorL[0].EndY*=1.1;
     }
     if (GetKeyState('P')&0x8000)
     {
        VectorL[0].BegX*=0.9;
        VectorL[0].BegY*=0.9;
        VectorL[0].EndX*=0.9;
        VectorL[0].EndY*=0.9;
     }
     if (GetKeyState('K')&0x8000)
     {
        VectorL[0].BegX*=-1;
        VectorL[0].EndX*=-1;
     }
     if (GetKeyState('L')&0x8000)
     {
        VectorL[0].BegY*=-1;
        VectorL[0].EndY*=-1;
     }

     if (GetKeyState(VK_UP  )&0x8000)
     {
	CameraForewardMotion();
     }else
     if (GetKeyState(VK_DOWN)&0x8000)
     {
	CameraBackwardMotion();
     }
     CPP_TMakeTMatrix(TRotAdd,TMatrix,5);
}

void ClearZBuffer(void)
{
//     FillQWordDATA(ZBuffer,0x40590000,0x00000000,64000); // 100.0
     FillQWordDATA(ZBuffer,0x7FEE42D1,0x30773B75,64000);// 1.7E+308
}

void CheckFace(void)
{
     Facing= 1;
}

void Render_Object1(void)
{
     DWORD NumZClipped;
     DWORD NumXClipped;
     DWORD NumYClipped;
     DWORD CurL;
     SWORD x1,y1,x2,y2;
     ColorVal Lc;

     Lc.Color16=0xFFFF;

     NumZClipped=CPP_ZClipVisVrtx(&VertexL[30],&VertexL[40],Camera,4);

     if (NumZClipped)
     {
        CPP_TVertexLView(&VertexL[40],&ClpLine[0],NumZClipped,Camera);//17
        NumXClipped=CPP_XClipVisLine(&ClpLine[0],&ClpLine[5],Camera,NumZClipped);//19
        if (NumXClipped)
        {
           NumYClipped=CPP_YClipVisLine(&ClpLine[5],&ClpLine[12],Camera,NumXClipped);
           if (NumYClipped)
              for (CurL=0;CurL<NumYClipped;CurL++)
              {
                  x1=(SWORD)ClpLine[CurL+12].BegX;
                  y1=(SWORD)ClpLine[CurL+12].BegY;
                  x2=(SWORD)ClpLine[CurL+12].EndX;
                  y2=(SWORD)ClpLine[CurL+12].EndY;
                  DrawEdge(x1,y1,x2,y2);
              }
           ProcessEdges(VirtScr,&VertexL[34],&VectorL[4],Camera,0<<12);
/*           if (NumYClipped)
              for (CurL=0;CurL<NumYClipped;CurL++)
              {
                  x1=(SWORD)ClpLine[CurL+12].BegX;
                  y1=(SWORD)ClpLine[CurL+12].BegY;
                  x2=(SWORD)ClpLine[CurL+12].EndX;
                  y2=(SWORD)ClpLine[CurL+12].EndY;
                  Line(x1,y1,x2,y2,VirtScr,Lc);
              }*/
        }
     }
}

void Render_Object2(void)
{
     DWORD NumZClipped;
     DWORD NumXClipped;
     DWORD NumYClipped;
     DWORD CurL;
     SWORD x1,y1,x2,y2;
     ColorVal Lc;

     Lc.Color16=0xFFFF;

     NumZClipped=CPP_ZClipVisVrtx(&VertexL[35],&VertexL[45],Camera,4);

     if (NumZClipped)
     {
        CPP_TVertexLView(&VertexL[45],&ClpLine[0],NumZClipped,Camera);//17
        NumXClipped=CPP_XClipVisLine(&ClpLine[0],&ClpLine[5],Camera,NumZClipped);//19
        if (NumXClipped)
        {
           NumYClipped=CPP_YClipVisLine(&ClpLine[5],&ClpLine[12],Camera,NumXClipped);
           if (NumYClipped)
              for (CurL=0;CurL<NumYClipped;CurL++)
              {
                  x1=(SWORD)ClpLine[CurL+12].BegX;
                  y1=(SWORD)ClpLine[CurL+12].BegY;
                  x2=(SWORD)ClpLine[CurL+12].EndX;
                  y2=(SWORD)ClpLine[CurL+12].EndY;
                  DrawEdge(x1,y1,x2,y2);
              }
           ProcessEdges(VirtScr,&VertexL[39],&VectorL[5],Camera,9<<12);
/*           if (NumYClipped)
              for (CurL=0;CurL<NumYClipped;CurL++)
              {
                  x1=(SWORD)ClpLine[CurL+12].BegX;
                  y1=(SWORD)ClpLine[CurL+12].BegY;
                  x2=(SWORD)ClpLine[CurL+12].EndX;
                  y2=(SWORD)ClpLine[CurL+12].EndY;
                  Line(x1,y1,x2,y2,VirtScr,Lc);
              }*/
        }
     }
}

void Engine_UpdateDisplay(void)
{
     FillByteDATA(VirtScr,0,VirtualScrSize);

     ProcessKeyboardInput();

//     CPP_TransVectorL(&VectorL[   0],&VectorL[   2],&TMatrix[3],   1);

     CPP_TransVertexL(&VertexL[   0],&VertexL[  10],&TMatrix[0],   5);// obj1
     CPP_TransVectorL(&VectorL[   0],&VectorL[   2],&TMatrix[0],   1);// obj1
     CPP_TransVertexL(&VertexL[   5],&VertexL[  15],&TMatrix[2],   5);// obj2
     CPP_TransVectorL(&VectorL[   1],&VectorL[   3],&TMatrix[2],   1);// obj2

     CPP_TransVertexL(&VertexL[  10],&VertexL[  20],&TMatrix[1],   5);// obj1
     CPP_TransVertexL(&VertexL[  15],&VertexL[  25],&TMatrix[3],   5);// obj2

     CPP_TransVertexL(&VertexL[  20],&VertexL[  30],&TMatrix[4],  10);// obj1+obj2
     CPP_TransVectorL(&VectorL[   2],&VectorL[   4],&TMatrix[4],   2);// obj1+obj2

     CheckFace();

     ClearZBuffer();
     SetEdges();
     Render_Object1();
     SetEdges();
     Render_Object2();
}


void Engine_Destroy(void)
{
     free(Texture);
     free(ZBuffer);
     free(Edges  );
     free(Camera );
     free(ClpLine);
     free(TMatrix);
     free(TRotAdd);
     free(VectorL);
     free(VertexL);
}
