#include "trans.h"
#include <math.h>

void  CPP_TMakeTMatrix(DATA_TRotAdd *SrcD,
                       DATA_TMatrix *DstD,
                       DWORD         NumM
                      )
{
      FLOATINGPOINT SinX,SinY,SinZ,CosX,CosY,CosZ;
      DWORD CurM;
      for (CurM=0;CurM<NumM;CurM++)
      {
          SinX=sin(SrcD[CurM].RotX*SrcD[CurM].FixMul);
          CosX=cos(SrcD[CurM].RotX*SrcD[CurM].FixMul);
          SinY=sin(SrcD[CurM].RotY*SrcD[CurM].FixMul);
          CosY=cos(SrcD[CurM].RotY*SrcD[CurM].FixMul);
          SinZ=sin(SrcD[CurM].RotZ*SrcD[CurM].FixMul);
          CosZ=cos(SrcD[CurM].RotZ*SrcD[CurM].FixMul);
          DstD[CurM].M0=(SinX*SinY*SinZ)+(CosY*CosZ);
          DstD[CurM].M1=(SinX*SinY*CosZ)-(CosY*SinZ);
          DstD[CurM].M2=-SinY*CosX;
          DstD[CurM].M3=0;
          DstD[CurM].M4=CosX*SinZ;
          DstD[CurM].M5=CosX*CosZ;
          DstD[CurM].M6=SinX;
          DstD[CurM].M7=0;
          DstD[CurM].M8=( SinY*CosZ     )-(SinX*CosY*SinZ);
          DstD[CurM].M9=(-CosY*SinX*CosZ)-(SinY*SinZ     );
          DstD[CurM].MA=CosY*CosX;
          DstD[CurM].MB=0;
          DstD[CurM].MC=SrcD[CurM].AddX;
          DstD[CurM].MD=SrcD[CurM].AddY;
          DstD[CurM].ME=SrcD[CurM].AddZ;
          DstD[CurM].MF=0;
      }
}

void  CPP_TransVertexL(DATA_VertexL *SrcV,
                       DATA_VertexL *DstV,
                       DATA_TMatrix *TrsM,
                       DWORD         NumV
                      )
{
      DWORD CurV;
      for (CurV=0;CurV<NumV;CurV++)
      {
          DstV[CurV].BegX=(                TrsM[0].MC)+
                          (SrcV[CurV].BegX*TrsM[0].M0)+
                          (SrcV[CurV].BegY*TrsM[0].M4)+
                          (SrcV[CurV].BegZ*TrsM[0].M8);
          DstV[CurV].BegY=(                TrsM[0].MD)+
                          (SrcV[CurV].BegX*TrsM[0].M1)+
                          (SrcV[CurV].BegY*TrsM[0].M5)+
                          (SrcV[CurV].BegZ*TrsM[0].M9);
          DstV[CurV].BegZ=(                TrsM[0].ME)+
                          (SrcV[CurV].BegX*TrsM[0].M2)+
                          (SrcV[CurV].BegY*TrsM[0].M6)+
                          (SrcV[CurV].BegZ*TrsM[0].MA);
          DstV[CurV].EndX=(                TrsM[0].MC)+
                          (SrcV[CurV].EndX*TrsM[0].M0)+
                          (SrcV[CurV].EndY*TrsM[0].M4)+
                          (SrcV[CurV].EndZ*TrsM[0].M8);
          DstV[CurV].EndY=(                TrsM[0].MD)+
                          (SrcV[CurV].EndX*TrsM[0].M1)+
                          (SrcV[CurV].EndY*TrsM[0].M5)+
                          (SrcV[CurV].EndZ*TrsM[0].M9);
          DstV[CurV].EndZ=(                TrsM[0].ME)+
                          (SrcV[CurV].EndX*TrsM[0].M2)+
                          (SrcV[CurV].EndY*TrsM[0].M6)+
                          (SrcV[CurV].EndZ*TrsM[0].MA);
      }

}
void  CPP_TransVectorL(DATA_VectorL *SrcV,
                       DATA_VectorL *DstV,
                       DATA_TMatrix *TrsM,
                       DWORD              NumV
                      )
{
      DWORD CurV;
      for (CurV=0;CurV<NumV;CurV++)
      {
          DstV[CurV].BegX=(SrcV[CurV].BegX*TrsM[0].M0)+
                          (SrcV[CurV].BegY*TrsM[0].M4)+
                          (SrcV[CurV].BegZ*TrsM[0].M8);
          DstV[CurV].BegY=(SrcV[CurV].BegX*TrsM[0].M1)+
                          (SrcV[CurV].BegY*TrsM[0].M5)+
                          (SrcV[CurV].BegZ*TrsM[0].M9);
          DstV[CurV].BegZ=(SrcV[CurV].BegX*TrsM[0].M2)+
                          (SrcV[CurV].BegY*TrsM[0].M6)+
                          (SrcV[CurV].BegZ*TrsM[0].MA);
          DstV[CurV].EndX=(SrcV[CurV].EndX*TrsM[0].M0)+
                          (SrcV[CurV].EndY*TrsM[0].M4)+
                          (SrcV[CurV].EndZ*TrsM[0].M8);
          DstV[CurV].EndY=(SrcV[CurV].EndX*TrsM[0].M1)+
                          (SrcV[CurV].EndY*TrsM[0].M5)+
                          (SrcV[CurV].EndZ*TrsM[0].M9);
          DstV[CurV].EndZ=(SrcV[CurV].EndX*TrsM[0].M2)+
                          (SrcV[CurV].EndY*TrsM[0].M6)+
                          (SrcV[CurV].EndZ*TrsM[0].MA);
      }
}

void  CPP_TVertexLView(DATA_VertexL *SrcV,
                       DATA_ClpLine *DstL,
                       DWORD         NumV,
                       DATA__Camera *Camm
                      )
{     DWORD CurV;
      FLOATINGPOINT Z;
      for (CurV=0;CurV<NumV;CurV++)
      {
          Z=SrcV[CurV].BegZ;
          // z=Scale/Z;
//          if (Z==0)Z=0.00000001;
          DstL[CurV].BegX=((SrcV[CurV].BegX*Camm[0].Scale)/Z)+Camm[0].MidX;
          DstL[CurV].BegY=((SrcV[CurV].BegY*Camm[0].Scale)/Z)+Camm[0].MidY;
          DstL[CurV].BegZ=SrcV[CurV].BegZ;
          Z=SrcV[CurV].EndZ;
//          if (Z==0)Z=0.00000001;
          DstL[CurV].EndX=((SrcV[CurV].EndX*Camm[0].Scale)/Z)+Camm[0].MidX;
          DstL[CurV].EndY=((SrcV[CurV].EndY*Camm[0].Scale)/Z)+Camm[0].MidY;
          DstL[CurV].EndZ=SrcV[CurV].EndZ;
      }
}
//eof