#include "engine.h"
#include <math.h>
#pragma pack(1)
#define NUM_Pie                                3.14159265358979323846

struct OneEDGE
{
       SWORD BegX,EndX;
};
DATA__Camera   *Camera;
DATA_VertexL   *VertexL;
DATA_VectorL   *VectorL;
DATA_VectorL   *CameraM;
DATA_TRotAdd   *TRotAdd;
DATA_TMatrix   *TMatrix;
DATA_ClpLine   *ClpLine;
WORD           *Texture;
OneEDGE        *Edges;
FLOATINGPOINT      *ZBuffer;

void Init3DObject(void)
{
     FLOATINGPOINT Angle;
     FLOATINGPOINT IncA=360.0/16.0;
     DWORD SaveV;
     Angle=0.0;
     for (SaveV=0;SaveV<16;SaveV++)
     {
         VertexL[SaveV].BegX=sin(Angle*(NUM_Pie/180))*32;
         VertexL[SaveV].BegY=cos(Angle*(NUM_Pie/180))*32;
         VertexL[SaveV].BegZ=0;
         VertexL[SaveV].EndX=sin((Angle+IncA)*(NUM_Pie/180))*32;
         VertexL[SaveV].EndY=cos((Angle+IncA)*(NUM_Pie/180))*32;
         VertexL[SaveV].EndZ=0;
         Angle+=IncA;
     }
     VertexL[  15].EndX=VertexL[   0].BegX;
     VertexL[  15].EndY=VertexL[   0].BegY;
     VertexL[  16].BegX=VertexL[  16].EndX=0;
     VertexL[  16].BegY=VertexL[  16].EndY=0;
     VectorL[0].BegX=0;
     VectorL[0].BegY=1;
     VectorL[0].BegZ=0;
     VectorL[0].EndX=1;
     VectorL[0].EndY=0;
     VectorL[0].EndZ=0;
     TRotAdd[0].AddX=0;
     TRotAdd[0].AddY=0;
     TRotAdd[0].AddZ=0;
     TRotAdd[0].RotX=90;
     TRotAdd[0].RotY=0;
     TRotAdd[0].RotZ=0;
     TRotAdd[0].FixMul=(FLOATINGPOINT)NUM_Pie/(FLOATINGPOINT)180;
     TRotAdd[1].AddX=0;
     TRotAdd[1].AddY=0;
     TRotAdd[1].AddZ=0;//550;
     TRotAdd[1].RotX=0;
     TRotAdd[1].RotY=0;
     TRotAdd[1].RotZ=0;
     TRotAdd[1].FixMul=(FLOATINGPOINT)NUM_Pie/(FLOATINGPOINT)180;
     TRotAdd[2].AddX=0;
     TRotAdd[2].AddY=0;
     TRotAdd[2].AddZ=0;
     TRotAdd[2].RotX=0;
     TRotAdd[2].RotY=0;
     TRotAdd[2].RotZ=0;
     TRotAdd[2].FixMul=(FLOATINGPOINT)NUM_Pie/(FLOATINGPOINT)180;
     TRotAdd[3].FixMul=(FLOATINGPOINT)NUM_Pie/(FLOATINGPOINT)180;
     TRotAdd[3].RotX=TRotAdd[3].RotY=TRotAdd[3].RotZ=0;
     CameraM[0].BegX=   0;
     CameraM[0].BegY=   0;
     CameraM[0].BegZ= -10;
     CameraM[0].EndX=   0;
     CameraM[0].EndY=   0;
     CameraM[0].EndZ=  10;
}

void InitCamera(void)
{
     Camera[0].BegX=0  ;//+60;
     Camera[0].BegY=0  ;//+40;
     Camera[0].EndX=319;//-60;
     Camera[0].EndY=199;//-40;
     Camera[0].MidX=160;
     Camera[0].MidY=100;
     Camera[0].Scale=256;
     Camera[0].FocalDist=1;
}

void LoadBitmapInText(const char *FileName,DWORD AddAmount)
{
     HFILE hf;
     DWORD NumR;
     struct
     {
            BYTE B,G,R;
     }Col;
     hf=_lopen(FileName,OF_READ);
     _llseek(hf,-12288,FILE_END);
     for (NumR=0;NumR<4096;NumR++)
     {
         _lread(hf,&Col,3);
         Col.R>>=3;
         Col.G>>=2;
         Col.B>>=3;
         Texture[NumR+AddAmount]=(WORD)((WORD)Col.R<<11)|(WORD)((WORD)Col.G<<5)|(WORD)Col.B;
     }
     _lclose(hf);
}

BOOL Engine_Init(void)
{
     DWORD a;
     VertexL=(DATA_VertexL   *)malloc(sizeof(DATA_VertexL  )*(100));//21
     CameraM=(DATA_VectorL   *)malloc(sizeof(DATA_VectorL  )*   2);
     VectorL=(DATA_VectorL   *)malloc(sizeof(DATA_VectorL  )*   3);
     TRotAdd=(DATA_TRotAdd   *)malloc(sizeof(DATA_TRotAdd  )*   4);
     TMatrix=(DATA_TMatrix   *)malloc(sizeof(DATA_TMatrix  )*   4);
     ClpLine=(DATA_ClpLine   *)malloc(sizeof(DATA_ClpLine  )*(100));//14
     Camera =(DATA__Camera   *)malloc(sizeof(DATA__Camera  )*   1);
     Edges  =(OneEDGE        *)malloc(sizeof(OneEDGE       )* 200);
     ZBuffer=(FLOATINGPOINT  *)malloc(sizeof(FLOATINGPOINT )*64000);
     Texture=(WORD           *)malloc(sizeof(WORD          )*(4096*11));
     if (VertexL==NULL)return(FALSE);
     if (CameraM==NULL)return(FALSE);
     if (VectorL==NULL)return(FALSE);
     if (TRotAdd==NULL)return(FALSE);
     if (TMatrix==NULL)return(FALSE);
     if (ClpLine==NULL)return(FALSE);
     if (Camera ==NULL)return(FALSE);
     if (Edges  ==NULL)return(FALSE);
     if (ZBuffer==NULL)return(FALSE);
     if (Texture==NULL)return(FALSE);
     Init3DObject();
     InitCamera();
     // load only 11
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv1.bmp"         , 0<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv2.bmp"         , 1<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv3.bmp"         , 2<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv4.bmp"         , 3<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\tv5.bmp"         , 4<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\fence2.bmp"      , 5<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\hwall.bmp"       , 6<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\window.bmp"      , 7<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\door.bmp"        , 8<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\bush.bmp"        , 9<<12);
     LoadBitmapInText("..\\..\\media\\bitmaps\\24-bit\\grass.bmp"       ,10<<12);
     return(TRUE);
}

void SetEdges(void)
{    WORD EdgeLoop;
     for (EdgeLoop=0;EdgeLoop<200;EdgeLoop++)
     {
         Edges[EdgeLoop].BegX= 321;
         Edges[EdgeLoop].EndX=  -1;
     }
}

void Line(register SDWORD  BegX
              ,register SDWORD  BegY
              ,         SDWORD  EndX
              ,         SDWORD  EndY
              ,WORD       *Adr
              ,         WORD    Col
              )
{    SDWORD  DelX,DelY,AddYH,AddXH,AddYL,AddXL,Accum,AddAH,AddAL;
     DWORD   LargeDist,SmallDist,LineL,EdgeN;

     DelX=EndX-BegX;
     DelY=EndY-BegY;
     if (DelX<0)
     {
        DelX       =-DelX;
        AddXH=AddXL=-1;
     }  else
     {
        AddXH=AddXL= 1;
     }
     if (DelY<0)
     {
        DelY       =-DelY;
        AddYH=AddYL=-1;
     }  else
     {
        AddYH=AddYL= 1;
     }
     if (DelX>DelY)
     {
        LargeDist=DelX;
        SmallDist=DelY;
        AddYL=0;
     }  else
     {
        LargeDist=DelY;
        SmallDist=DelX;
        AddXL=0;
     }
     SmallDist<<=1;
     Accum=SmallDist-LargeDist;
     AddAL=SmallDist;
     AddAH=SmallDist-(LargeDist<<1);
     for (LineL=0;LineL<=LargeDist;LineL++)
     {

         if (  (BegX>=0)
             &&(BegY>=0)
             &&(BegX<320)
             &&(BegY<200))
            Adr[(BegY*320)+BegX]=Col;
         if (Accum>=0)
         {
            BegX +=AddXH;
            BegY +=AddYH;
            Accum+=AddAH;
         }  else
         {  BegX +=AddXL;
            BegY +=AddYL;
            Accum+=AddAL;
         }
     }

}

void DrawEdge(register SWORD  BegX
                  ,register SWORD  BegY
                  ,         SWORD  EndX
                  ,         SWORD  EndY
                  )
{    SWORD  DelX,DelY,AddYH,AddXH,AddYL,AddXL,Accum,AddAH,AddAL;
     WORD   LargeDist,SmallDist,LineL,EdgeN;

     DelX=EndX-BegX;
     DelY=EndY-BegY;
     if (DelX<0)
     {
        DelX       =-DelX;
        AddXH=AddXL=-1;
     }  else
     {
        AddXH=AddXL= 1;
     }
     if (DelY<0)
     {
        DelY       =-DelY;
        AddYH=AddYL=-1;
     }  else
     {
        AddYH=AddYL= 1;
     }
     if (DelX>DelY)
     {
        LargeDist=DelX;
        SmallDist=DelY;
        AddYL=0;
     }  else
     {
        LargeDist=DelY;
        SmallDist=DelX;
        AddXL=0;
     }
     SmallDist<<=1;
     Accum=SmallDist-LargeDist;
     AddAL=SmallDist;
     AddAH=SmallDist-(LargeDist<<1);
     for (LineL=0;LineL<=LargeDist;LineL++)
     {

         if (  (BegX>=0)
             &&(BegY>=0)
             &&(BegX<320)
             &&(BegY<200))
         {
            if (BegX<Edges[BegY].BegX)Edges[BegY].BegX=BegX;
            if (BegX>Edges[BegY].EndX)Edges[BegY].EndX=BegX;
         }
         if (Accum>=0)
         {
            BegX +=AddXH;
            BegY +=AddYH;
            Accum+=AddAH;
         }  else
         {  BegX +=AddXL;
            BegY +=AddYL;
            Accum+=AddAL;
         }
     }

}

void ProcessEdges(WORD         *Adr,
                  DATA_VertexL *Vrtx,
                  DATA_VectorL *Vctr,
                  DATA__Camera *Camm)
{
     SDWORD CurE,LoopX;
     DATA_TxtScan Tsd;
     WORD v0=0,u0=0;
     FLOAT tx,ty,tz;
     DWORD TX,TY,Shade;
     DWORD Color;
     DWORD ScrPoint;
     WORD Pal;
     WORD ShadeL;
     Tsd.v0=0;
     Tsd.u0=0;
     Tsd.Ox=Vrtx[0].BegX;
     Tsd.Oy=Vrtx[0].BegY;
     Tsd.Oz=Vrtx[0].BegZ;
     Tsd.Vx=Vctr[0].BegX;
     Tsd.Vy=Vctr[0].BegY;
     Tsd.Vz=Vctr[0].BegZ;
     Tsd.Ux=Vctr[0].EndX;
     Tsd.Uy=Vctr[0].EndY;
     Tsd.Uz=Vctr[0].EndZ;
     Tsd.Ui=(Tsd.Vz*Tsd.Oy)-(Tsd.Oz*Tsd.Vy);
     Tsd.Uj=(Tsd.Vx*Tsd.Oz)-(Tsd.Ox*Tsd.Vz);
     Tsd.Uc=(Tsd.Vy*Tsd.Ox)-(Tsd.Oy*Tsd.Vx);
     Tsd.Vi=(Tsd.Uy*Tsd.Oz)-(Tsd.Oy*Tsd.Uz);
     Tsd.Vj=(Tsd.Uz*Tsd.Ox)-(Tsd.Oz*Tsd.Ux);
     Tsd.Vc=(Tsd.Ux*Tsd.Oy)-(Tsd.Ox*Tsd.Uy);
     Tsd.Zi=(Tsd.Vy*Tsd.Uz)-(Tsd.Uy*Tsd.Vz);
     Tsd.Zj=(Tsd.Vz*Tsd.Ux)-(Tsd.Uz*Tsd.Vx);
     Tsd.Zc=(Tsd.Vx*Tsd.Uy)-(Tsd.Ux*Tsd.Vy);
     TX=0;
     TY=0;
     Color=0;
     for (CurE=0;CurE<200;CurE++)
     {
         if ((Edges[CurE].BegX>=0)&&(Edges[CurE].EndX<320))
         {  Tsd.j=((FLOAT)CurE-Camm[0].MidY)/Camm[0].Scale;
            Tsd.xx=(Tsd.j*Tsd.Uj)+Tsd.Uc;
            Tsd.yy=(Tsd.j*Tsd.Vj)+Tsd.Vc;
	    Tsd.zz=(Tsd.j*Tsd.Zj)+Tsd.Zc;
	    for (LoopX=Edges[CurE].BegX;LoopX<=Edges[CurE].EndX;LoopX++)
	    {
		ScrPoint=(CurE*320)+LoopX;
//		if (LoopX&4)
//		{
		Tsd.i=((FLOAT)LoopX-Camm[0].MidX)/Camm[0].Scale;
		Tsd.zzz=Tsd.zz+(Tsd.i*Tsd.Zi);
		Tsd.u=(Tsd.xx+(Tsd.i*Tsd.Ui))/Tsd.zzz;
		Tsd.v=(Tsd.yy+(Tsd.i*Tsd.Vi))/Tsd.zzz;
		Tsd.z=Tsd.Oz+(Tsd.u*Tsd.Uz)+(Tsd.v*Tsd.Vz);
		if ((ZBuffer[ScrPoint]>Tsd.z)&&(Tsd.z>=Camm[0].FocalDist))
		{
		   ZBuffer[ScrPoint]=Tsd.z;
//                   *(BYTE *)&TX=(BYTE)Tsd.u+(BYTE)Tsd.u0;
//                   *(BYTE *)&TY=(BYTE)Tsd.v+(BYTE)Tsd.v0;
		   TX=(DWORD)Tsd.u+(DWORD)Tsd.u0;
		   TY=(DWORD)Tsd.v+(DWORD)Tsd.v0;
		   TX&=63;
		   TY&=63;
		   Color=(DWORD)((DWORD)TY<<6)+(DWORD)TX;
		   Adr[ScrPoint]=Texture[(DWORD)Color];
		}
//		}
//		   Adr[ScrPoint]=Texture[(DWORD)Color];
	    }
	 }
     }
}

void CameraForewardMotion(void)
{
     FLOATINGPOINT fl1,fl2;
     fl1=(-TRotAdd[2].RotY)+180;
     fl2=(-TRotAdd[2].RotX);
     TRotAdd[1].AddX+= sin(fl1*TRotAdd[2].FixMul);
     TRotAdd[1].AddY+= sin(fl2*TRotAdd[2].FixMul);
     TRotAdd[1].AddZ+= cos(fl1*TRotAdd[2].FixMul);
}

void CameraBackwardMotion(void)
{
     FLOATINGPOINT fl1,fl2;
     fl1=(-TRotAdd[2].RotY);
     fl2=(-TRotAdd[2].RotX)+180;
     TRotAdd[1].AddX+= sin(fl1*TRotAdd[2].FixMul);
     TRotAdd[1].AddY+= sin(fl2*TRotAdd[2].FixMul);
     TRotAdd[1].AddZ+= cos(fl1*TRotAdd[2].FixMul);
}

void ProcessKeyboardInput(void)
{
     if (GetKeyState('W')&0x8000)
     {
	TRotAdd[0].RotX-=1;
     }else
     if (GetKeyState('S')&0x8000)
     {
	TRotAdd[0].RotX+=1;
     }
     if (GetKeyState('D')&0x8000)
     {
	TRotAdd[0].RotY-=1;
     }else
     if (GetKeyState('A')&0x8000)
     {
	TRotAdd[0].RotY+=1;
     }
     if (GetKeyState('Q')&0x8000)
     {
	TRotAdd[0].RotZ-=1;
     }else
     if (GetKeyState('E')&0x8000)
     {
	TRotAdd[0].RotZ+=1;
     }

     if (GetKeyState('T')&0x8000)
     {
	TRotAdd[2].RotX-=1;
     }else
     if (GetKeyState('G')&0x8000)
     {
	TRotAdd[2].RotX+=1;
     }
     if (GetKeyState('H')&0x8000)
     {
	TRotAdd[2].RotY-=1;
     }else
     if (GetKeyState('F')&0x8000)
     {
	TRotAdd[2].RotY+=1;
     }
     if (GetKeyState('R')&0x8000)
     {
	TRotAdd[2].RotZ-=1;
     }else
     if (GetKeyState('Y')&0x8000)
     {
	TRotAdd[2].RotZ+=1;
     }

     if (GetKeyState('1')&0x8000)TRotAdd[1].AddX-=10;else
     if (GetKeyState('2')&0x8000)TRotAdd[1].AddX+=10;
     if (GetKeyState('3')&0x8000)TRotAdd[1].AddY-=10;else
     if (GetKeyState('4')&0x8000)TRotAdd[1].AddY+=10;
     if (GetKeyState('5')&0x8000)TRotAdd[1].AddZ-=10;else
     if (GetKeyState('6')&0x8000)TRotAdd[1].AddZ+=10;

/*     TRotAdd[3].RotX=-TRotAdd[2].RotX;
     TRotAdd[3].RotY= TRotAdd[2].RotY;
     TRotAdd[3].RotZ=-TRotAdd[2].RotZ;*/
     if (GetKeyState(VK_UP  )&0x8000)
     {
/*	CPP_TMakeTMatrix(&TRotAdd[3],&TMatrix[3],1);
	CPP_TransVectorL(&CameraM[0],&CameraM[1],&TMatrix[3],1);*/
	CameraForewardMotion();
     }else
     if (GetKeyState(VK_DOWN)&0x8000)
     {
/*	CPP_TMakeTMatrix(&TRotAdd[3],&TMatrix[3],1);
	CPP_TransVectorL(&CameraM[0],&CameraM[1],&TMatrix[3],1);*/
	CameraBackwardMotion();
     }
     CPP_TMakeTMatrix(TRotAdd,TMatrix,4);
}

void ClearZBuffer(void)
{    WORD CurZ;
     for (CurZ=0;CurZ<64000;CurZ++)
     ZBuffer[CurZ]=100000000000;
}

void Engine_UpdateDisplay(void)
{
     DWORD NumZClipped;
     DWORD NumXClipped;
     DWORD NumYClipped;
     DWORD CurL;
     SWORD x1,y1,x2,y2;

     TRotAdd[3].RotZ+=2;
     SetEdges();
     FillByteDATA(VirtScr,0,VirtualScrSize);

     ProcessKeyboardInput();

     CPP_TransVectorL(&VectorL[   0],&VectorL[   1],&TMatrix[3],   1);

     CPP_TransVertexL(&VertexL[   0],&VertexL[  17],&TMatrix[0],  17);
     CPP_TransVectorL(&VectorL[   1],&VectorL[   2],&TMatrix[0],   1);

     CPP_TransVertexL(&VertexL[  17],&VertexL[  34],&TMatrix[1],  17);

     CPP_TransVertexL(&VertexL[  34],&VertexL[  51],&TMatrix[2],  17);
     CPP_TransVectorL(&VectorL[   2],&VectorL[   1],&TMatrix[2],   1);
     NumZClipped=CPP_ZClipVisVrtx(&VertexL[51],&VertexL[68],Camera,16);
     if (NumZClipped)
     {
        CPP_TVertexLView(&VertexL[68],&ClpLine[0],NumZClipped,Camera);//17
        NumXClipped=CPP_XClipVisLine(&ClpLine[0],&ClpLine[17],Camera,NumZClipped);//19
        if (NumXClipped)
        {
           NumYClipped=CPP_YClipVisLine(&ClpLine[17],&ClpLine[36],Camera,NumXClipped);
           if (NumYClipped)
              for (CurL=0;CurL<NumYClipped;CurL++)
              {
                  x1=(SWORD)ClpLine[CurL+36].BegX;
                  y1=(SWORD)ClpLine[CurL+36].BegY;
                  x2=(SWORD)ClpLine[CurL+36].EndX;
                  y2=(SWORD)ClpLine[CurL+36].EndY;
   //               Line(x1,y1,x2,y2,VirtScr,65535);
                  DrawEdge(x1,y1,x2,y2);
              }
	   ClearZBuffer();
           ProcessEdges(VirtScr,&VertexL[67],&VectorL[1],Camera);
        }
     }
}


void Engine_Destroy(void)
{
     free(Texture);
     free(ZBuffer);
     free(Edges  );
     free(Camera );
     free(ClpLine);
     free(TMatrix);
     free(TRotAdd);
     free(VectorL);
     free(CameraM);
     free(VertexL);
}
